/*
	$Id: Return.java 294 2006-09-06 15:57:45Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ͤηǤ

   returnǤбޤ
*/
public class Return {

    /** type° */
    private String type;

    /** descǤ */
    private Description desc;

    /**
       ͤηޤ

       @param g 롼
       @param nodes return
    */
    public Return(final Group g, final NodeList nodes) {
	type = "void";

	if (nodes == null || nodes.getLength() == 0) {
	    return;
	}
	Element elem = (Element) nodes.item(0);
	type = g.expandAT(elem, "type");
	g.importTags(type);

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ɤǽϤͤηɽ¦ʸޤ

       @return ͤηɽ¦ʸ
    */
    public String getLeftCode() {
	int k = type.indexOf('#');
	if (k == -1) {
	    return type + " ";
	}
	return type.substring(0, k);
    }

    /**
       ɤǽϤͤηɽ¦ʸޤ

       @return ͤηɽ¦ʸ
    */
    public String getRightCode() {
	int k = type.indexOf('#');
	if (k == -1) {
	    return "";
	}
	return type.substring(k + 1);
    }

    /**
       HTMLǽϤͤηɽʸޤ

       @return ͤηɽʸ
    */
    public String getText() {
	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", "");
	}
	return type;
    }

    /**
       TeXǽϤͤηɽʸޤ

       @return ͤηɽʸ
    */
    public String getTexText() {
	return Tex.safe(getText());
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (desc == null) {
	    return;
	}
	wr.println(""
+ "<dl>Returns:<dd>" + desc.getText() + "</dd></dl>");
   }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (desc == null) {
	    return;
	}
	wr.println("\\Sreturn");
	wr.println("\\begin{Sindentation}{\\Sindentlength}{0pt}");
	wr.println(desc.getTexText());
	wr.println("\\end{Sindentation}");
    }
}
